public class SetImpl<E extends Ordered> implements Set<E> {
    private CircularlyDblLinkedList<E> list;
    
    public SetImpl() {
        list = new CircularlyDblLinkedList<E>();
    }
    public SetImpl(SetImpl<E> set) {
        list = set.copyList();
        dedupe();
    }
    public SetImpl(E[] arr) {
        list = new CircularlyDblLinkedList<E>();
        for(int i = 0; i < arr.length; i++)
            list.add(i, arr[i]);
        dedupe();
    }
    
    //TODO: implement interface Set
    
    //helper methods
    private CircularlyDblLinkedList<E> copyList() {
        CircularlyDblLinkedList<E> dst = new CircularlyDblLinkedList<E>();
        int i = 0;
        for(E e : list)
            dst.add(i++, e);
        return dst;
    }

    //TODO: remove duplicated elements (do not sort the list)
    private void dedupe() {
    }
    
    private static void onFalseThrow(boolean b) {
        if(!b)
            throw new RuntimeException("Error: unexpected");            
    }
    public static void main(String[] args) {
        Int _1 = new Int(1);
        Int _2 = new Int(2);
        Int _3 = new Int(3);
        SetImpl<Int> a = new SetImpl<Int>(new Int[] {_1});
        SetImpl<Int> b = new SetImpl<Int>(new Int[] {_1, _2});
        SetImpl<Int> c = new SetImpl<Int>(new Int[] {_2, _3});
        SetImpl<Int> e = new SetImpl<Int>();
        SetImpl<Int> x = new SetImpl<Int>(new Int[] {_1, _1, _1});
        SetImpl<Int> y = new SetImpl<Int>(new Int[] {_1, _2, _1, _2});
        SetImpl<Int> z = new SetImpl<Int>(new Int[] {_3, _2, _3, _3});
        SetImpl<Int> u = new SetImpl<Int>(new Int[] {_1, _2, _3});
        
        onFalseThrow(x.isEqual(a)); 
        onFalseThrow(y.isEqual(b)); 
        onFalseThrow(z.isEqual(c));
        onFalseThrow(y.union(z).isEqual(u));
        onFalseThrow(x.intersection(y).isEqual(x));
        onFalseThrow(x.intersection(z).isEqual(e));
        onFalseThrow(u.difference(z).isEqual(x));
        System.out.println("Success!");
    }    
}
